def add_user_rights_folder(label, permission_level="RX", security_identifier="S-1-5-11"):
    """Add write, read, execute and delete rights from user on label folder and childrens

    Args:
        label (str): label of folder to change rights
        security_identifier (str): Windows SID (by default : Authenticated Users)
        https://docs.microsoft.com/en-us/troubleshoot/windows-server/identity/security-identifiers-in-windows
        permission_level (str): permission mask (by default : Read and execute access )
        https://docs.microsoft.com/en-us/windows-server/administration/windows-commands/icacls
    """

    run(r'icacls.exe "%s" /inheritancelevel:d /grant *%s:(%s) /t /C /q' % (label, security_identifier, permission_level))
