def install():
    # Force install to purge drivers (resets a VM to the state before any of the I/O drivers were installed)
    if Version(to_uninstall["version"]) >= Version("9.3.1") and force:
        temp_warning_file = r"C:\Windows\Temp\citrix-vm-tools-warning.txt"
        if not isfile(temp_warning_file):
            run(f'echo warning sent > "{temp_warning_file}"')
            error(
                "WARNING: friendly warning to recommend that you take a snapshot of your VM before cleaning drivers. You can then re-run force install to do this."
            )
        killalltasks(ensure_list(control.impacted_process))
        uninstaller_path = makepath(programfiles, "Citrix", "XenTools", "uninstall.exe")
        run(f'"{uninstaller_path}" purge verbose')
        wait_uninstallkey_absent(to_uninstall["key"])
