def audit():
    audit_status = "OK"
    battery_report_file = get_private_persistent_package_file("batteryreport.xml")
    dmi_info_portable_battery = dmi_info().get("Portable_Battery", None)
    if dmi_info_portable_battery:
        get_batteryreport(battery_report_file)
        battery_report_dict = {}
        batteries_dict_list = get_battery_capacities_from_xml(battery_report_file)
        battery_count = len(batteries_dict_list)
        battery_report_dict.update({"battery_count": str(battery_count)})
        # WAPT.write_audit_data_if_changed("battery-report",, str(battery_count))
        for i in range(0, battery_count, 1):
            battery_number_name = f"BATTERY_{str(i+1)}"
            # print(battery_number_name + ":")
            full_charge_capacity = batteries_dict_list[i]["FullChargeCapacity"]
            design_capacity = batteries_dict_list[i]["DesignCapacity"]
            battery_health = str(int(int(full_charge_capacity) * 100 / int(design_capacity))) + " %"

            batteries_dict_list[i].update({"Health": battery_health})
            batteries_dict_list[i].update(dmi_info_portable_battery[i])
            # WAPT.write_audit_data_if_changed("battery-report", battery_number_name, batteries_dict_list[i])
            # print(batteries_dict_list[i])
            print(
                f'{battery_number_name} ({batteries_dict_list[i]["Location"]}) Health is {batteries_dict_list[i]["Health"]} for the Design_Capacity {batteries_dict_list[i]["Design_Capacity"]} with Design_Voltage {batteries_dict_list[i]["Design_Voltage"]}.'
            )
            battery_report_dict.update({battery_number_name: batteries_dict_list[i]})
        WAPT.write_audit_data_if_changed("battery-report", "battery-report", battery_report_dict)
    else:
        print("No battery detected.")
    return audit_status
