# -*- coding: utf-8 -*-
from setuphelpers import *
from setupdevhelpers import *


def update_package():
    # Declaring local variables
    package_updated = False
    proxies = get_proxies_from_wapt_console()
    if not proxies:
        proxies = get_proxies()
    download_dict = {
        "windows-x64": "https://static.rust-lang.org/dist/rust-1.70.0-x86_64-pc-windows-msvc.msi",
        "windows-x86": "https://static.rust-lang.org/dist/rust-1.70.0-i686-pc-windows-msvc.msi",
        "windows-all": "https://static.rust-lang.org/dist/rust-1.70.0-i686-pc-windows-msvc.msi",
        "linux-x64": "https://static.rust-lang.org/dist/rust-1.70.0-x86_64-unknown-linux-gnu.tar.gz",
        "linux-arm64": "https://static.rust-lang.org/dist/rust-1.70.0-x86_64-unknown-linux-gnu.tar.gz",
        "macos-x64": "https://static.rust-lang.org/dist/rust-1.70.0-x86_64-apple-darwin.pkg",
        "macos-arm64": "https://static.rust-lang.org/dist/rust-1.70.0-aarch64-unknown-linux-gnu.tar.gz",
    }
    download_url = download_dict[ensure_list(control.target_os)[0].split("(")[0] + "-" + ensure_list(control.architecture)[0]]
    download_url = "https://go.microsoft.com/fwlink/?linkid=2088631"
    latest_bin = download_url.split("/")[-1]
    latest_bin = "ndp48-x86-x64-allos-enu.exe"

    # Deleting binaries
    remove_outdated_binaries("*")

    # Downloading latest binaries
    print("Download URL is: %s" % download_url)
    if not isfile(latest_bin):
        print("Downloading: %s" % latest_bin)
        wget(download_url, latest_bin, proxies=proxies)
    else:
        print("Binary is present: %s" % latest_bin)

    # Checking version from file
    if get_os_name() == "Windows" and "windows" in control.target_os.lower():
        version = get_version_from_binary(latest_bin)
    else:
        version = control.get_software_version()

    # Changing version of the package
    if Version(version, 4) > Version(control.get_software_version(), 4):
        print("Software version updated (from: %s to: %s)" % (control.get_software_version(), Version(version)))
        package_updated = True
    else:
        print("Software version up-to-date (%s)" % Version(version))
    control.set_software_version(version)
    control.save_control_to_wapt()

    # Validating update-package-sources
    return package_updated

    # # Changing version of the package and validating update-package-sources
    # return complete_control_version(control, version)
