# -*- coding: utf-8 -*-
from setuphelpers import *


app_name = "Anki"
app_dir = makepath(programfiles, app_name)
app_path = makepath(app_dir, "anki.exe")
app_uninstallstring = makepath(app_dir, "uninstall.exe")
icon_path = app_path
audit_version = False
win64app = True


def install():
    bin_name = glob.glob("anki-*-windows-qt6.exe")[0]

    # Uninstalling older major versions of the software
    for to_uninstall in installed_softwares(app_name):
        if Version(to_uninstall["version"], 1) < Version(control.get_software_version(), 1):
            print("Removing: %s (%s)" % (to_uninstall["name"], to_uninstall["version"]))
            killalltasks(ensure_list(control.impacted_process))
            run(uninstall_cmd(to_uninstall["key"]))
            wait_uninstallkey_absent(to_uninstall["key"])

    # Installing software
    if need_install(key=app_name, min_version=control.get_software_version()) or force:
        install_exe_if_needed(
            bin_name,
            # silentflags=r"/NCRC /S /D=C:\Program Files\anki",
            silentflags=rf"/NCRC /S /D={app_dir}",
            key="",
            min_version=control.get_software_version(),
            timeout=600,
        )

        # Adding software to regitry
        print("Registering: %s to Windows Registry" % app_name)
        register_windows_uninstall(control, win64app=win64app)
        app_quiet_uninstall_string = rf'"{app_uninstallstring}" /S'
        register_uninstall(
            app_name,
            win64app=win64app,
            install_location=app_dir,
            icon=icon_path,
            uninstallstring=app_uninstallstring,
            quiet_uninstall_string=app_quiet_uninstall_string,
        )

    else:
        print(f"{app_name} ({control.get_software_version()}) is already installed and up-to-date.")
        uninstallkey.append(app_name)

    # Deleting user registry install
    registry_deletekey(HKEY_CURRENT_USER, r"Software\Microsoft\Windows\CurrentVersion\Uninstall", app_name)


def uninstall():
    # Deleting registry install
    unregister_uninstall(app_name)


# def session_setup():
#     mkdirs(makepath(user_appdata, "Anki2"))
#     run(r'echo software > "%APPDATA%\Anki2\gldriver6"')
